Welcome to Subscribe On Youtube

Question

Formatted question description: https://leetcode.ca/all/116.html

You are given a perfect binary tree where all leaves are on the same level, and every parent has two children. The binary tree has the following definition:

struct Node {
  int val;
  Node *left;
  Node *right;
  Node *next;
}

Populate each next pointer to point to its next right node. If there is no next right node, the next pointer should be set to NULL.

Initially, all next pointers are set to NULL.

 

Example 1:

Input: root = [1,2,3,4,5,6,7]
Output: [1,#,2,3,#,4,5,6,7,#]
Explanation: Given the above perfect binary tree (Figure A), your function should populate each next pointer to point to its next right node, just like in Figure B. The serialized output is in level order as connected by the next pointers, with '#' signifying the end of each level.

Example 2:

Input: root = []
Output: []

 

Constraints:

  • The number of nodes in the tree is in the range [0, 212 - 1].
  • -1000 <= Node.val <= 1000

 

Follow-up:

  • You may only use constant extra space.
  • The recursive approach is fine. You may assume implicit stack space does not count as extra space for this problem.

Algorithm

DFS

Since it is a complete binary tree, if a node has a left child, then its right child must also exist. Therefore, the next pointer of the left child can directly point to its right child.

To process the right child, we check whether the next pointer of its parent node is empty. If it is not empty, it points to the left child of the node pointed to by its next pointer. If it is empty, it points to NULL.

BFS

We need to use a queue to assist with the breadth-first search. The nodes in each level are added to the queue in order, and whenever an element is taken from the queue, its next pointer can be pointed to the next node in the queue.

Before starting the traversal of the elements at the beginning of each level, we first count the total number of nodes in the level, and use a for loop to ensure that when the loop ends, the entire level has been traversed.

Code

  • import java.util.LinkedList;
    import java.util.Queue;
    
    public class Populating_Next_Right_Pointers_in_Each_Node {
    
    	/**
    	 * Definition for binary tree with next pointer.
    	 * public class TreeLinkNode {
    	 *     int val;
    	 *     TreeLinkNode left, right, next;
    	 *     TreeLinkNode(int x) { val = x; }
    	 * }
    	 */
    
        // just a bfs
        public class Solution_iteration {
            public void connect(TreeLinkNode root) {
    
                if (root == null) {
                    return;
                }
    
                Queue<TreeLinkNode> q = new LinkedList<>();
    
                TreeLinkNode levelEndMarker = new TreeLinkNode(0);
                TreeLinkNode prev = new TreeLinkNode(0);
    
                q.offer(root);
                q.offer(levelEndMarker);
    
                while (!q.isEmpty()) {
                    TreeLinkNode current = q.poll();
    
                    if (current == levelEndMarker) {
                        // push marker again as next level end
                        if (!q.isEmpty()) { // @note: missed final check again...
                            q.offer(levelEndMarker);
                        }
    
                        // first node of each level, can not be last of upper level
                        prev = levelEndMarker; // can be any node which is not in this tree
                        continue;
                    }
    
                    if (current.left != null) {
                        q.offer(current.left);
                    }
                    if (current.right != null) {
                        q.offer(current.right);
                    }
    
                    prev.next = current;
                    prev = current;
                }
            }
        }
    
        public class Solution_recursion {
            public void connect(TreeLinkNode root) {
                connect(root, null);
            }
    
            private void connect(TreeLinkNode current, TreeLinkNode next) {
                if (current == null) {
                    return;
                } else {
                    current.next = next; // connect
                }
    
                connect(current.left, current.right);
    
                if (next != null) {
                    connect(current.right, next.left);
                } else {
    	            /*next == null*/
                    connect(current.right, null);
                }
            }
        }
    
    }
    
    ############
    
    /*
    // Definition for a Node.
    class Node {
        public int val;
        public Node left;
        public Node right;
        public Node next;
    
        public Node() {}
    
        public Node(int _val) {
            val = _val;
        }
    
        public Node(int _val, Node _left, Node _right, Node _next) {
            val = _val;
            left = _left;
            right = _right;
            next = _next;
        }
    };
    */
    
    class Solution {
        public Node connect(Node root) {
            if (root == null) {
                return root;
            }
            Deque<Node> q = new ArrayDeque<>();
            q.offer(root);
            while (!q.isEmpty()) {
                Node p = null;
                for (int n = q.size(); n > 0; --n) {
                    Node node = q.poll();
                    if (p != null) {
                        p.next = node;
                    }
                    p = node;
                    if (node.left != null) {
                        q.offer(node.left);
                    }
                    if (node.right != null) {
                        q.offer(node.right);
                    }
                }
            }
            return root;
        }
    }
    
  • // OJ: https://leetcode.com/problems/populating-next-right-pointers-in-each-node/
    // Time: O(N)
    // Space: O(N)
    class Solution {
    public:
        Node* connect(Node* root) {
            if (!root) return nullptr;
            queue<Node*> q{ {root} };
            while (q.size()) {
                int cnt = q.size();
                Node *prev = nullptr;
                while (cnt--) {
                    auto node = q.front();
                    q.pop();
                    if (prev) prev->next = node;
                    prev = node;
                    if (node->left) q.push(node->left);
                    if (node->right) q.push(node->right);
                }
            }
            return root;
        }
    };
    
  • """
    # Definition for a Node.
    class Node:
        def __init__(self, val: int = 0, left: 'Node' = None, right: 'Node' = None, next: 'Node' = None):
            self.val = val
            self.left = left
            self.right = right
            self.next = next
    """
    
    '''
    >>> d = deque((5,1,9,2))
    >>> d.popleft()
    5
    >>> d.popleft()
    1
    >>>
    >>>
    >>> d = deque([5,1,9,2])
    >>> d.popleft()
    5
    >>> d.popleft()
    1
    '''
    
    from collections import deque
    
    class Solution:
        def connect(self, root: "Optional[Node]") -> "Optional[Node]":
            if root is None:
                return root
    
            # q = deque(root) ===> TypeError: 'Node' object is not iterable
            # make it a list [], so it's iterable
            q = deque([root])
            while q:
                p = None
                for _ in range(len(q)):
                    node = q.popleft()
                    if p:
                        p.next = node
                    p = node
                    if node.left:
                        q.append(node.left)
                    if node.right:
                        q.append(node.right)
            return root
    
    
    class Solution:
        def connect(self, root: 'Node') -> 'Node':
            if not root:
                return root
    
            l = [root] # list
    
            while l:
                size = len(l)
                for i in range(size):
                    node = l.pop(0) # pop() is last, pop(0) is first of list
                    if i < size - 1:
                        node.next = l[0]
                    if node.left:
                        l.append(node.left)
                    if node.right:
                        l.append(node.right)
    
            return root
    
    # recursion
    class Solution:
        def connect(self, root: "Optional[Node]") -> "Optional[Node]":
            self._connect(root, None)
            return root
    
        def _connect(self, current: 'Optional[Node]', next_node: 'Optional[Node]') -> None:
            if current is None:
                return
            else:
                current.next = next_node  # connect
    
            self._connect(current.left, current.right)
    
            if next_node is not None:
                self._connect(current.right, next_node.left)
            else:
                self._connect(current.right, None)
    
  • /**
     * Definition for a Node.
     * type Node struct {
     *     Val int
     *     Left *Node
     *     Right *Node
     *     Next *Node
     * }
     */
    
    func connect(root *Node) *Node {
    	if root == nil {
    		return root
    	}
    	q := []*Node{root}
    	for len(q) > 0 {
    		var p *Node
    		for n := len(q); n > 0; n-- {
    			node := q[0]
    			q = q[1:]
    			if p != nil {
    				p.Next = node
    			}
    			p = node
    			if node.Left != nil {
    				q = append(q, node.Left)
    			}
    			if node.Right != nil {
    				q = append(q, node.Right)
    			}
    		}
    	}
    	return root
    }
    
  • /**
     * Definition for Node.
     * class Node {
     *     val: number
     *     left: Node | null
     *     right: Node | null
     *     next: Node | null
     *     constructor(val?: number, left?: Node, right?: Node, next?: Node) {
     *         this.val = (val===undefined ? 0 : val)
     *         this.left = (left===undefined ? null : left)
     *         this.right = (right===undefined ? null : right)
     *         this.next = (next===undefined ? null : next)
     *     }
     * }
     */
    
    function connect(root: Node | null): Node | null {
        if (root == null || root.left == null) {
            return root;
        }
        const { left, right, next } = root;
        left.next = right;
        if (next != null) {
            right.next = next.left;
        }
        connect(left);
        connect(right);
        return root;
    }
    
    

All Problems

All Solutions